////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float blendWeight;

void main()
{
    highp vec4 inputColor = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 effectColor = texture2D(inputImageTexture2, textureCoordinate) * blendWeight;

    vec4 finalColor  = vec4((inputColor + effectColor).rgb, effectColor.a);

    gl_FragColor = finalColor;
}
