////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

void main()
{
    highp vec4 baseColor = texture2D(inputImageTexture, textureCoordinate);
    highp vec4 cropColor = texture2D(inputImageTexture2, textureCoordinate);
    highp vec4 maskColor = texture2D(inputImageTexture3, textureCoordinate);

    // 根据条件判断设置mask
    float mask =0.;
    if (maskColor.a > 0.) {
        mask = maskColor.a;
    }

    // 应用mask到输出颜色
    vec4 finalColor  = vec4((baseColor * mask + cropColor * (1.0-mask)).rgb, cropColor.a);

    // 输出最终颜色
    gl_FragColor = finalColor;
}